Vue.component("genome-viewer",{
  template: `
    <div>
      <div class="container-lin-dna">
        <div :id="genomeStats.id" class="lin-dna" :data-cluster-start="genomeStats.start" :data-cluster-end="genomeStats.end" style="width: 100%; height: 50px;">
          <div v-for="feature in featureData" :key="feature.name" class="region-to-display" :data-region-name="feature.name" :data-region-description="feature.description" :data-region-start="feature.start" :data-region-end="feature.end" :data-region-strand="feature.strand" :data-region-type="feature.type">
          </div>
        </div>
      </div>

      <!-- new stuff -->
      <!-- TODO: axis -->
      <axis>
      </axis>
      <!-- TODO: lanes -->
      <svg :height="400" :width="1000">
      <lane v-for="(lane, index) in lanes" :key="lane.id" :x="0" :y="100*index" :height="100" :width="1000">
      </lane>
      </svg>
      <!-- TODO: features -->
      <feature v-for="feature in featureData" :key="feature.name">
      </feature>
    </div>`,
  props: {
    genomeStats: {
      validator (value) {
        for (let property of ['id', 'start', 'end']) {
          if (!value.hasOwnProperty(property)) {
            return false
          }
        }
        return true
      }
    },
    featureData: {
      validator (value) {
        for (let feature of value) {
          for (let property of ['name', 'description', 'start', 'end', 'strand', 'type']) {
            if (!feature.hasOwnProperty(property)) {
              return false
            }
          }
          return true
        }
      }
    }
  },
  data: function(){
    return {
      lanes: [-1, 1]
    }
  },
})
